' =============================================
'  GCOE G2 v1.0.7 - Development
'  Created by (Rogan) Shea Trevor Rial
'  Written in QBasic 7.1 with the Future.lib
'  for Mouse, Sound, and SVGA support
' =============================================

' ==[ Include External Files ]=================

  '$INCLUDE: 'future.bi'

' ==[ Subroutine Declares ]====================

  DECLARE FUNCTION Trim$ (iStr AS STRING)
  DECLARE FUNCTION GetClr& (iNum AS INTEGER, iDrk AS INTEGER)
  DECLARE FUNCTION checkEqual% (iStrA AS STRING, iCompare AS STRING, iStrB AS STRING)
  DECLARE FUNCTION GetChr$ (PID AS INTEGER)
  DECLARE FUNCTION getStringData$ (PID AS INTEGER)
  DECLARE FUNCTION requestNewPID% ()
  DECLARE FUNCTION getData% (PID AS INTEGER)
  DECLARE FUNCTION notUnderZero% (iNum AS INTEGER)
  DECLARE FUNCTION MouseInArea% (iLeft AS INTEGER, iTop AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER)
  DECLARE FUNCTION returnFontWidth (iStr AS STRING)
  DECLARE SUB FontPrint (iText AS STRING, iLeft AS INTEGER, iTop AS INTEGER)
  DECLARE SUB loadFont (FontFilename AS STRING)
  DECLARE SUB drwButton (iLeft AS INTEGER, iTop AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER, iCaption AS STRING, iState AS INTEGER)
  DECLARE SUB DrawDashedBorder (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER)
  DECLARE SUB CheckClicks ()
  DECLARE SUB SetDashedBorder (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER)
  DECLARE SUB RestoreDashedBorder (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER)
  DECLARE SUB UpdateMouse ()
  DECLARE SUB drwWin (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER, iCaption AS STRING, iActive AS INTEGER, iResize AS INTEGER)
  DECLARE SUB drwGrad (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER, iStartColor AS LONG, iEndColor AS LONG)
  DECLARE SUB NextChr (PID AS INTEGER)
  DECLARE SUB SystemRefresh ()
  DECLARE SUB SwapPage ()
  DECLARE SUB CurPage ()
  DECLARE SUB MouseClear ()
  DECLARE SUB MouseRefresh ()
  DECLARE SUB ResetZOrder (PID AS INTEGER)
  DECLARE SUB runRoutine (PID AS INTEGER, iStr AS STRING)
  DECLARE SUB ExecCommand (PID AS INTEGER, iStr AS STRING)
    
' ==[ Global Variable Declares ]===============

  '$DYNAMIC:
  DIM SHARED Mem(20, 50) AS STRING
  '$DYNAMIC:
  DIM SHARED DashedBorder(640, 3) AS LONG
  DIM SHARED iFont(255) AS STRING
  DIM SHARED iFontX(255) AS INTEGER
  DIM SHARED iFontY(255) AS INTEGER
  DIM SHARED FontSpace AS INTEGER
  DIM SHARED FontSpacing AS INTEGER
  DIM SHARED FontHeight AS INTEGER
  DIM SHARED FontFilename AS STRING
  DIM SHARED oldFontFilename AS STRING

' ==[ Inital Variable Setup ]==================
Init:

  CHDIR "C:\G2"
  Mem(0, 0) = COMMAND$
  Mem(0, 1) = "GCOE G2 v1.0.7"
  iDone = 0

' ==[ System Startup ]=========================
SystemStartup:

  PRINT : COLOR 15: PRINT "  " + Mem(0, 1); : COLOR 7
  IF INSTR(LCASE$(Mem(0, 0)), "-") <> 0 THEN
    Mem(0, 20) = Trim$(MID$(COMMAND$, INSTR(LCASE$(Mem(0, 0)), "-") + 1, LEN(Mem(0, 0))))
    PRINT " >> " + Mem(0, 20)
  ELSE
    PRINT " >> No startup application specified."
    SYSTEM
  END IF
    
' ==[ System Core Routine ]====================
Core:

  DO
    IF Mem(0, 21) <> "" THEN
      SystemRefresh
      Mem(0, 21) = ""
    END IF
    IF VAL(Mem(0, 9)) = 1 THEN
      UpdateMouse
    END IF
    CheckClicks
    FOR Looper = 1 TO 20
      IF Mem(Looper, 3) = "1" THEN
        runRoutine Looper, "program"
      END IF
      IF Mem(0, 24) <> "" THEN
        SHELL Mem(0, 24)
      END IF
      IF Mem(0, 20) <> "" THEN
        aTemp = requestNewPID
        Mem(aTemp, 2) = Trim$(STR$(aTemp))
        Mem(aTemp, 3) = "1"
        Mem(aTemp, 4) = Mem(0, 20)
        Mem(0, 20) = ""
        Mem(0, 21) = "1"
        ResetZOrder aTemp
        runRoutine aTemp, "init"
      END IF
    NEXT
    IF Mem(0, 23) <> "" THEN
      iDone = 1
    END IF
    IF Mem(0, 22) <> "" THEN
      iDone = 1
    END IF

  LOOP UNTIL iDone = 1

' ==[ System Shutdown or Restart ]=============

  Future.MouseOff
  SwapPage
  ReSetScreen

  IF Mem(0, 22) <> "" THEN
    FOR Looper = 0 TO 50
      FOR LooperID = 0 TO 20
        Mem(LooperID, Looper) = ""
      NEXT
    NEXT
    CLOSE
    GOTO Init
  END IF

SUB CheckClicks
  IF VAL(Mem(0, 6)) <> VAL(Mem(0, 10)) THEN
    CurZOrder = 0
    FOR LooperZOrder = 1 TO 20 STEP 1
      FOR LooperID = 1 TO 20 STEP 1
        IF LooperZOrder = VAL(Mem(LooperID, 5)) THEN
          iLeft = VAL(Mem(LooperID, 6))
          iTop = VAL(Mem(LooperID, 7))
          iWidth = VAL(Mem(LooperID, 8))
          iHeight = VAL(Mem(LooperID, 9))
          IF MouseInArea(iLeft, iTop, iWidth, iHeight) = 1 THEN
            IF VAL(Mem(LooperID, 5)) > CurZOrder THEN
              CurZOrder = VAL(Mem(LooperID, 5))
              CurPID = LooperID
            END IF
          END IF
        END IF
      NEXT
    NEXT
    IF CurZOrder = 0 THEN EXIT SUB
    IF NOT VAL(Mem(0, 6)) = 0 THEN
      IF CurZOrder = 20 THEN
        iLeft = VAL(Mem(CurPID, 6))
        iTop = VAL(Mem(CurPID, 7))
        iWidth = VAL(Mem(CurPID, 8))
        iHeight = VAL(Mem(CurPID, 9))
        IF MouseInArea(iLeft, iTop, iWidth - 61, 26) = 1 THEN
          iClickLeft = iLeft - VAL(Mem(0, 7))
          iClickTop = iTop - VAL(Mem(0, 8))
          iCurLeft = VAL(Mem(0, 7)) + iClickLeft
          iCurTop = VAL(Mem(0, 8)) + iClickTop
          MouseClear
          SetDashedBorder iCurLeft, iCurTop, iWidth, iHeight
          MouseRefresh
          DO UNTIL VAL(Mem(0, 6)) = 0
            UpdateMouse
            IF VAL(Mem(0, 7)) <> iLastX OR VAL(Mem(0, 8)) <> iLastY THEN
              MouseClear
              RestoreDashedBorder iCurLeft, iCurTop, iWidth, iHeight
              iCurLeft = VAL(Mem(0, 7)) + iClickLeft
              iCurTop = VAL(Mem(0, 8)) + iClickTop
              SetDashedBorder iCurLeft, iCurTop, iWidth, iHeight
              DrawDashedBorder iCurLeft, iCurTop, iWidth, iHeight
              MouseRefresh
            END IF
            iLastX = VAL(Mem(0, 7)): iLastY = VAL(Mem(0, 8))
          LOOP
          Mem(CurPID, 6) = Trim$(STR$(iCurLeft))
          Mem(CurPID, 7) = Trim$(STR$(iCurTop))
          Mem(0, 21) = "1"
        ELSEIF MouseInArea(iLeft + iWidth - 15, iTop + iHeight - 15, 15, 15) = 1 AND VAL(Mem(CurPID, 11)) = 1 THEN
          iClickLeft = (iLeft + iWidth) - VAL(Mem(0, 7))
          iClickTop = (iTop + iHeight) - VAL(Mem(0, 8))
          iCurLeft = VAL(Mem(0, 7)) + iClickLeft - iLeft
          iCurTop = VAL(Mem(0, 8)) + iClickTop - iTop
          MouseClear
          SetDashedBorder iLeft, iTop, iWidth, iHeight
          MouseRefresh
          DO UNTIL VAL(Mem(0, 6)) = 0
            UpdateMouse
            IF VAL(Mem(0, 7)) <> iLastX OR VAL(Mem(0, 8)) <> iLastY THEN
              MouseClear
              RestoreDashedBorder iLeft, iTop, iCurLeft, iCurTop
              IF NOT VAL(Mem(0, 7)) + iClickLeft - iLeft < 150 THEN
                iCurLeft = VAL(Mem(0, 7)) + iClickLeft - iLeft
              ELSE
                iCurLeft = 150
              END IF
              IF NOT VAL(Mem(0, 8)) + iClickTop - iTop < 70 THEN
                iCurTop = VAL(Mem(0, 8)) + iClickTop - iTop
              ELSE
                iCurTop = 70
              END IF
              SetDashedBorder iLeft, iTop, iCurLeft, iCurTop
              DrawDashedBorder iLeft, iTop, iCurLeft, iCurTop
              MouseRefresh
            END IF
            iLastX = VAL(Mem(0, 7)): iLastY = VAL(Mem(0, 8))
          LOOP
          Mem(CurPID, 8) = Trim$(STR$(iCurLeft))
          Mem(CurPID, 9) = Trim$(STR$(iCurTop))
          Mem(0, 21) = "1"
        ELSE
          runRoutine CurPID, "mouseon"
        END IF
      ELSE
        ResetZOrder CurPID
        Mem(0, 21) = "1"
        Mem(0, 6) = "0": Mem(0, 10) = "0"
      END IF
    ELSEIF CurZOrder = 20 THEN
      runRoutine CurPID, "mouseoff"
    END IF
  END IF
END SUB

FUNCTION checkEqual (iStrA AS STRING, iCompare AS STRING, iStrB AS STRING)
  IsEqual = 0
  IF iCompare = CHR$(250) THEN
    IF iStrA = iStrB THEN
      IsEqual = 1
    END IF
  ELSEIF iCompare = CHR$(249) THEN
    IF VAL(iStrA) > VAL(iStrB) THEN
      IsEqual = 1
    END IF
  ELSEIF iCompare = CHR$(248) THEN
    IF VAL(iStrA) >= VAL(iStrB) THEN
      IsEqual = 1
    END IF
  ELSEIF iCompare = CHR$(247) THEN
    IF VAL(iStrA) < VAL(iStrB) THEN
      IsEqual = 1
    END IF
  ELSEIF iCompare = CHR$(246) THEN
    IF VAL(iStrA) <= VAL(iStrB) THEN
      IsEqual = 1
    END IF
  ELSEIF iCompare = CHR$(245) THEN
    IF NOT iStrA = iStrB THEN
      IsEqual = 1
    END IF
  END IF
  checkEqual = IsEqual
END FUNCTION

SUB CurPage
  iCurPage = VAL(Mem(0, 5))
  IF iCurPage = 0 THEN
    ViewPage 0
  ELSEIF iCurPage = 1 THEN
    ViewPage 1
  END IF
END SUB

SUB DrawDashedBorder (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER)
  IF iWidth > 1023 OR iHeight > 1023 THEN EXIT SUB
  FOR Looper = 0 TO iWidth / 2 STEP 1
    Future.PSet iX + (Looper * 2), iY, GetClr(33, 0)
    Future.PSet iX + (Looper * 2), iY + iHeight, GetClr(33, 0)
  NEXT
  FOR Looper = 0 TO iHeight / 2 STEP 1
    Future.PSet iX, iY + (Looper * 2), GetClr(33, 0)
    Future.PSet iX + iWidth, iY + (Looper * 2), GetClr(33, 0)
  NEXT
END SUB

SUB drwButton (iLeft AS INTEGER, iTop AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER, iCaption AS STRING, iState AS INTEGER)
  IF iState = 0 THEN ' Up
    iDrk = 0
  ELSEIF iState = 1 THEN ' Down
    iDrk = VAL(Mem(0, 50))
  END IF
  iY1 = iTop: iH1 = iHeight / 3
  iY2 = iY1 + iH1: iH2 = iHeight / 4
  iY3 = iY2 + iH2: iH3 = iHeight - (iH1 + iH2) + 1
  iLeft2 = iLeft + iWidth: iTop2 = iTop + iHeight
  Future.Box iLeft - 1, iTop - 1, iLeft2 + 1, iTop2 + 1, GetClr(33, iDrk)
  drwGrad iLeft + 1, iY1, iWidth - 2, iH1, GetClr(40, iDrk), GetClr(41, iDrk)
  drwGrad iLeft + 1, iY2, iWidth - 2, iH2, GetClr(41, iDrk), GetClr(42, iDrk)
  drwGrad iLeft + 1, iY3, iWidth - 2, iH3, GetClr(42, iDrk), GetClr(43, iDrk)
  Future.Line iLeft, iTop, iLeft, iTop2, GetClr(40, iDrk), -1
  Future.Line iLeft2, iTop, iLeft2, iTop2, GetClr(42, iDrk), -1
  iX2 = INT((iWidth / 2) - (returnFontWidth(iCaption) / 2))
  FontPrint iCaption, iLeft + iX2, iTop + INT(((INT((iHeight - 1) - FontHeight)) / 2))
END SUB

SUB drwGrad (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER, iStartColor AS LONG, iEndColor AS LONG)
  DIM iRChange AS SINGLE
  DIM iGChange AS SINGLE
  DIM iBChange AS SINGLE
  DIM curClr AS LONG
  Color2RGB iStartColor, rTemp1, gTemp1, bTemp1
  Color2RGB iEndColor, rTemp2, gTemp2, bTemp2
  iRChange = (rTemp2 - rTemp1) / iHeight
  iGChange = (gTemp2 - gTemp1) / iHeight
  iBChange = (bTemp2 - bTemp1) / iHeight
  curR = rTemp1: curG = gTemp1: curB = bTemp1
  FOR Looper = 0 TO iHeight - 1 STEP 1
    curClr = RGB2Color(curR, curG, curB)
    Future.Line iX, iY + Looper, iX + iWidth, iY + Looper, curClr, -1
    curR = curR + iRChange
    curG = curG + iGChange
    curB = curB + iBChange
  NEXT
END SUB

SUB drwWin (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER, iCaption AS STRING, iActive AS INTEGER, iResize AS INTEGER)
  IF iActive = 1 THEN
    iDrk = 0
  ELSE
    iDrk = VAL(Mem(0, 50))
  END IF
  iX2 = iX + iWidth: iY2 = iY + iHeight
  Future.FillBox iX + 1, iY + 26, iX2 - 1, iY2 - 1, GetClr(32, 0)
  Future.Box iX, iY, iX2, iY2, GetClr(33, iDrk)
  Future.Line iX2 + 1, iY + 1, iX2 + 1, iY2 + 1, GetClr(33, iDrk), -1
  Future.Line iX + 1, iY2 + 1, iX2, iY2 + 1, GetClr(33, iDrk), -1
  Future.Line iX, iY + 25, iX2, iY + 25, GetClr(33, iDrk), -1
  Future.Line iX2 - 62, iY + 1, iX2 - 62, iY + 24, GetClr(33, iDrk), -1
  drwGrad iX + 2, iY + 1, iWidth - 66, 8, GetClr(40, iDrk), GetClr(41, iDrk)
  drwGrad iX + 2, iY + 9, iWidth - 66, 5, GetClr(41, iDrk), GetClr(42, iDrk)
  drwGrad iX + 2, iY + 14, iWidth - 66, 11, GetClr(42, iDrk), GetClr(43, iDrk)
  Future.Line iX + 1, iY + 1, iX + 1, iY + 24, GetClr(40, iDrk), -1
  Future.Line iX2 - 63, iY + 1, iX2 - 63, iY + 24, GetClr(42, iDrk), -1
  drwGrad iX2 - 60, iY + 1, 58, 8, GetClr(44, iDrk), GetClr(45, iDrk)
  drwGrad iX2 - 60, iY + 9, 58, 5, GetClr(45, iDrk), GetClr(46, iDrk)
  drwGrad iX2 - 60, iY + 14, 58, 11, GetClr(46, iDrk), GetClr(47, iDrk)
  Future.Line iX2 - 61, iY + 1, iX2 - 61, iY + 24, GetClr(44, iDrk), -1
  Future.Line iX2 - 1, iY + 1, iX2 - 1, iY + 24, GetClr(46, iDrk), -1
  IF iResize = 1 THEN
    Future.Line iX + iWidth - 10, iY + iHeight - 1, iX + iWidth - 1, iY + iHeight - 10, GetClr(33, 0), -1
    Future.Line iX + iWidth - 7, iY + iHeight - 1, iX + iWidth - 1, iY + iHeight - 7, GetClr(33, 0), -1
    Future.Line iX + iWidth - 4, iY + iHeight - 1, iX + iWidth - 1, iY + iHeight - 4, GetClr(33, 0), -1
  END IF

  IF NOT returnFontWidth(iCaption) > iWidth - 80 THEN
    iX2 = ((iWidth - 60) / 2) - (returnFontWidth(iCaption) / 2)
    FontPrint iCaption, iX + iX2, iY + ((24 / 2) - (FontHeight / 2))
  ELSE
    FOR Looper = LEN(iCaption) TO 1 STEP -1
      aTemp$ = Trim$(LEFT$(iCaption, Looper)) + "..."
      IF NOT returnFontWidth(aTemp$) > iWidth - 80 THEN
        iX2 = ((iWidth - 60) / 2) - (returnFontWidth(aTemp$) / 2)
        FontPrint aTemp$, iX + iX2, iY + ((24 / 2) - (FontHeight / 2))
        EXIT FOR
      END IF
    NEXT
  END IF
END SUB

SUB ExecCommand (PID AS INTEGER, iStr AS STRING)
  DIM curChr AS STRING * 1
  DIM wX AS INTEGER
  DIM wY AS INTEGER
  DIM wW AS INTEGER
  DIM wH AS INTEGER
  wX = VAL(Mem(PID, 6))
  wY = VAL(Mem(PID, 7))
  wX2 = wX + 1: wY2 = wY + 26
  wW = VAL(Mem(PID, 8))
  wH = VAL(Mem(PID, 9))
  SELECT CASE iStr: CASE CHR$(191) ' Print
    NextChr PID
    aTemp$ = getStringData$(PID)
    IF VAL(Mem(0, 2)) < 300 THEN
      IF INSTR(LCASE$(aTemp$), "/n") <> 0 THEN
        PRINT aTemp$
      ELSE
        PRINT aTemp$;
      END IF
    ELSE
      NextChr PID
      cTemp = getData(PID): NextChr PID
      bTemp = getData(PID)
      FontPrint aTemp$, wX2 + cTemp, wY2 + bTemp
    END IF
  CASE CHR$(197) ' Goto
    NextChr PID
    aTemp = getData(PID)
    Mem(PID, 1) = Trim$(STR$(aTemp))
  CASE CHR$(183) ' Set
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp$ = getStringData$(PID)
    Mem(PID, aTemp) = bTemp$
  CASE CHR$(195) ' Math
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp$ = GetChr(PID): NextChr PID
    dTemp = getData(PID)
    IF cTemp$ = CHR$(251) THEN
      Mem(PID, aTemp) = Trim$(STR$(bTemp + dTemp))
    ELSEIF cTemp$ = CHR$(252) THEN
      Mem(PID, aTemp) = Trim$(STR$(bTemp - dTemp))
    ELSEIF cTemp$ = CHR$(253) THEN
      Mem(PID, aTemp) = Trim$(STR$(bTemp * dTemp))
    ELSEIF cTemp$ = CHR$(254) THEN
      Mem(PID, aTemp) = Trim$(STR$(bTemp / dTemp))
    END IF
  CASE CHR$(198) ' Freefile
    NextChr PID
    aTemp = getData(PID)
    Mem(PID, aTemp) = Trim$(STR$(FREEFILE))
  CASE CHR$(208) ' LoadFont
    NextChr PID
    aTemp$ = getStringData(PID)
    loadFont aTemp$
  CASE CHR$(199) ' fOpen
    NextChr PID
    aTemp$ = getStringData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID)
    IF bTemp = 1 THEN
      OPEN aTemp$ FOR INPUT AS #cTemp
    ELSEIF bTemp = 2 THEN
      OPEN aTemp$ FOR OUTPUT AS #cTemp
    ELSEIF bTemp = 3 THEN
      OPEN aTemp$ FOR APPEND AS #cTemp
    END IF
  CASE CHR$(202) ' fClose
    NextChr PID
    aTemp = getData(PID)
    CLOSE #aTemp
  CASE CHR$(200) ' fInput
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID)
    INPUT #aTemp, cTemp$
    Mem(PID, bTemp) = cTemp$
  CASE CHR$(201) ' fPrint
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp$ = getStringData(PID)
    PRINT #aTemp, bTemp$
  CASE CHR$(220) ' fEof
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID)
    Mem(PID, aTemp) = Trim$(STR$(EOF(bTemp)))
  CASE CHR$(196) ' LoadImage
    NextChr PID
    aTemp$ = getStringData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID)
    IF RIGHT$(LCASE$(aTemp$), 3) = "bmp" THEN
      Future.LoadBMP aTemp$, bTemp + wX2, cTemp + wY2
    END IF
  CASE CHR$(217) ' Line
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID): NextChr PID
    dTemp = getData(PID): NextChr PID
    eTemp = getData(PID)
    Future.Line aTemp + wX2, bTemp + wY2, cTemp + wX2, dTemp + wY2, eTemp, -1
  CASE CHR$(218) ' Box
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID): NextChr PID
    dTemp = getData(PID): NextChr PID
    eTemp = getData(PID)
    Future.Box aTemp + wX2, bTemp + wY2, cTemp + wX2, dTemp + wY2, eTemp
  CASE CHR$(219) ' Fillbox
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID): NextChr PID
    dTemp = getData(PID): NextChr PID
    eTemp = getData(PID)
    Future.FillBox aTemp + wX2, bTemp + wY2, cTemp + wX2, dTemp + wY2, eTemp
  CASE CHR$(212) ' WinDrawArea
    SetViewPort wX2, wY2, wX + wW, wY + wH
  CASE CHR$(213) ' ResetDrawArea
    SetViewPort 0, 0, VAL(Mem(0, 2)), VAL(Mem(0, 3))
  CASE CHR$(215) ' FontWidth
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp$ = getStringData(PID)
    Mem(PID, aTemp) = Trim$(STR$(returnFontWidth(bTemp$)))
  CASE CHR$(214) ' Substring
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp$ = getStringData(PID): NextChr PID
    cTemp = getData(PID): NextChr PID
    dTemp = getData(PID)
    Mem(PID, aTemp) = MID$(bTemp$, cTemp, dTemp)
  CASE CHR$(216) ' Lcase
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp$ = getStringData(PID)
    Mem(PID, aTemp) = LCASE$(bTemp$)
  CASE CHR$(224) ' Ucase
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp$ = getStringData(PID)
    Mem(PID, aTemp) = UCASE$(bTemp$)
  CASE CHR$(187) ' If
    NextChr PID
    aTemp$ = getStringData(PID): NextChr PID
    bTemp$ = GetChr(PID): NextChr PID
    cTemp$ = getStringData(PID)
    IF checkEqual(aTemp$, bTemp$, cTemp$) = 0 THEN
      CurrentIfs = 1
      DO
        NextChr PID
        curChr = GetChr(PID)
        IF curChr = CHR$(187) THEN ' If
          CurrentIfs = CurrentIfs + 1
        ELSEIF curChr = CHR$(190) THEN ' EndIf
          CurrentIfs = CurrentIfs - 1
        ELSEIF curChr = CHR$(188) THEN ' Else
          IF CurrentIfs = 1 THEN
            EXIT DO
          END IF
        ELSEIF curChr = CHR$(189) THEN ' ElseIf
          IF CurrentIfs = 1 THEN
            NextChr PID
            aTemp$ = getStringData(PID): NextChr PID
            bTemp$ = GetChr(PID): NextChr PID
            cTemp$ = getStringData(PID)
            IF checkEqual(aTemp$, bTemp$, cTemp$) = 1 THEN
              EXIT DO
            END IF
          END IF
        END IF
        IF CurrentIfs = 0 THEN
          EXIT DO
        END IF
      LOOP
    END IF
  CASE CHR$(210) ' Click
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID): NextChr PID
    dTemp = getData(PID)
    aTemp = aTemp + wX2: bTemp = bTemp + wY2
    IF MouseInArea(aTemp, bTemp, cTemp, dTemp) = 0 THEN
      CurrentIfs = 1
      DO
        NextChr PID
        curChr = GetChr(PID)
        IF curChr = CHR$(210) THEN ' Click
          CurrentIfs = CurrentIfs + 1
        ELSEIF curChr = CHR$(211) THEN ' EndClick
          CurrentIfs = CurrentIfs - 1
        END IF
        IF CurrentIfs = 0 THEN
          EXIT DO
        END IF
      LOOP
    END IF
  CASE CHR$(206), CHR$(207) ' ButtonUp, ButtonDown
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID): NextChr PID
    dTemp = getData(PID): NextChr PID
    eTemp$ = getStringData(PID)
    aTemp = aTemp + wX2: bTemp = bTemp + wY2
    IF iStr = CHR$(206) THEN
      drwButton aTemp, bTemp, cTemp, dTemp, eTemp$, 0
    ELSEIF iStr = CHR$(207) THEN
      drwButton aTemp, bTemp, cTemp, dTemp, eTemp$, 1
    END IF
  CASE CHR$(188), CHR$(189) ' Else and ElseIf
    CurrentIfs = 1
    DO
      NextChr PID
      curChr = GetChr(PID)
      IF curChr = CHR$(187) THEN
        CurrentIfs = CurrentIfs + 1
      ELSEIF curChr = CHR$(190) THEN
        CurrentIfs = CurrentIfs - 1
      END IF
      IF CurrentIfs = 0 THEN
        EXIT DO
      END IF
    LOOP
  CASE CHR$(194) ' SetScreenMode
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID)
    Mem(0, 2) = Trim$(STR$(aTemp))
    Mem(0, 3) = Trim$(STR$(bTemp))
    Mem(0, 4) = Trim$(STR$(cTemp))
    SetScreenMode aTemp, bTemp, cTemp
  CASE CHR$(203) ' Rgb
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID): NextChr PID
    dTemp = getData(PID)
    Mem(PID, aTemp) = Trim$(STR$(RGB2Color(bTemp, cTemp, dTemp)))
  CASE CHR$(186) ' DirectMemoryRead
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp = getData(PID)
    IF bTemp = 0 AND cTemp = 11 THEN
      Mem(PID, aTemp) = INKEY$
    ELSEIF bTemp = 0 AND cTemp = 12 THEN
      Mem(PID, aTemp) = DATE$
    ELSEIF bTemp = 0 AND cTemp = 13 THEN
      Mem(PID, aTemp) = TIME$
    ELSEIF bTemp = 0 AND cTemp = 14 THEN
      Mem(PID, aTemp) = Trim$(STR$(Pages))
    ELSEIF bTemp = 0 AND cTemp = 15 THEN
      Mem(PID, aTemp) = Trim$(STR$(IsVESA))
    ELSEIF bTemp = 0 AND cTemp = 16 THEN
      Mem(PID, aTemp) = Trim$(STR$(IsMMX))
    ELSEIF bTemp = 0 AND cTemp = 17 THEN
      Mem(PID, aTemp) = Trim$(STR$(IsEMMInstalled))
    ELSEIF bTemp = 0 AND cTemp = 18 THEN
      Mem(PID, aTemp) = Trim$(STR$(IsXMSInstalled))
    ELSEIF bTemp = 0 AND cTemp = 19 THEN
      Mem(PID, aTemp) = Trim$(STR$(FreeXMSmemory))
    ELSE
      Mem(PID, aTemp) = Mem(bTemp, cTemp)
    END IF
  CASE CHR$(185) ' DirectMemoryWrite
    NextChr PID
    aTemp = getData(PID): NextChr PID
    bTemp = getData(PID): NextChr PID
    cTemp$ = getStringData(PID)
    Mem(aTemp, bTemp) = cTemp$
  CASE CHR$(204) ' MouseClear
    MouseClear
  CASE CHR$(205) ' MouseRefresh
    MouseRefresh
  CASE CHR$(182) ' RefreshWindow
    iLeft = VAL(Mem(PID, 6))
    iTop = VAL(Mem(PID, 7))
    iWidth = VAL(Mem(PID, 8))
    iHeight = VAL(Mem(PID, 9))
    iCaption$ = Mem(PID, 10)
    IF VAL(Mem(PID, 5)) = 20 THEN
      iActive = 1
    ELSE
      iActive = 0
    END IF
    drwWin iLeft, iTop, iWidth, iHeight, iCaption$, iActive, VAL(Mem(PID, 11))
  END SELECT
END SUB

SUB FontPrint (iText AS STRING, iLeft AS INTEGER, iTop AS INTEGER)
  iFontColor& = ColorVS
  FOR Looper = 1 TO LEN(iText)
    CurPos = 1
    CChr = ASC(MID$(iText, Looper, 1))
    IF NOT MID$(iText, Looper, 1) = " " THEN
      Work$ = iFont(CChr)
      FOR bLooper = 1 TO iFontY(CChr)
        dNum = 16
        FOR cLooper = 1 TO iFontX(CChr)
          dNum = dNum - 1
          WorkChr = VAL(MID$(Work$, CurPos, 1))
          IF WorkChr = 1 THEN
            Future.PSet CLoc + iLeft + cLooper, iTop + bLooper, GetClr(34, 0)
          END IF
          CurPos = CurPos + 1
        NEXT
      NEXT
      CLoc = CLoc + iFontX(CChr) + FontSpacing
    ELSE
      CLoc = CLoc + FontSpace
    END IF
  NEXT
END SUB

FUNCTION GetChr$ (PID AS INTEGER)
  GetChr$ = MID$(Mem(PID, 0), VAL(Mem(PID, 1)), 1)
END FUNCTION

FUNCTION GetClr& (iNum AS INTEGER, iDrk AS INTEGER)
  IF iDrk = 0 THEN
    GetClr& = VAL(Mem(0, iNum))
  ELSE
    Color2RGB VAL(Mem(0, iNum)), rTemp, gTemp, bTemp
    rTemp = notUnderZero(rTemp - iDrk)
    gTemp = notUnderZero(gTemp - iDrk)
    bTemp = notUnderZero(bTemp - iDrk)
    GetClr& = RGB2Color(rTemp, gTemp, bTemp)
  END IF
END FUNCTION

FUNCTION getData (PID AS INTEGER)
  getData = VAL(getStringData(PID))
END FUNCTION

FUNCTION getStringData$ (PID AS INTEGER)
  DIM curChr AS STRING * 1
  intStartPos = VAL(Mem(PID, 1))
  aTemp$ = ""
  IsMemory = 0
  FOR Looper = VAL(Mem(PID, 1)) TO LEN(Mem(PID, 0))
    curChr = MID$(Mem(PID, 0), Looper, 1)
    IF curChr = CHR$(184) THEN
      IsMemory = 1
    ELSEIF curChr = CHR$(255) THEN
      Mem(PID, 1) = Trim$(STR$(Looper))
      EXIT FOR
    ELSE
      aTemp$ = aTemp$ + curChr
    END IF
  NEXT
  IF IsMemory = 0 THEN
    getStringData = aTemp$
  ELSE
    getStringData$ = Mem(PID, VAL(aTemp$))
  END IF
END FUNCTION

SUB loadFont (FontFilename AS STRING)
  IF NOT oldFontFilename = FontFilename THEN
    Filenum = FREEFILE
    OPEN FontFilename FOR INPUT AS #Filenum
      INPUT #Filenum, aTemp$
      FontSpacing = VAL(Trim$(aTemp$))
      INPUT #Filenum, aTemp$
      FontSpace = VAL(Trim$(aTemp$))
      INPUT #Filenum, aTemp$
      FontHeight = VAL(Trim$(aTemp$))
      DO UNTIL EOF(Filenum)
        LINE INPUT #Filenum, Temp$
        IF Temp$ = "" THEN EXIT DO
        iRequest = ASC(Temp$)
        LINE INPUT #Filenum, Temp$
        iFontX(iRequest) = VAL(Temp$)
        LINE INPUT #Filenum, Temp$
        iFontY(iRequest) = VAL(Temp$)
        LINE INPUT #Filenum, Temp$
        iFont(iRequest) = Temp$
      LOOP
    CLOSE #Filenum
    oldFontFilename = FontFilename
  END IF
END SUB

SUB MouseClear
  Future.MouseOff
  Mem(0, 9) = "0"
END SUB

FUNCTION MouseInArea% (iLeft AS INTEGER, iTop AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER)
  aTemp = 1
  iMouseX = VAL(Mem(0, 7))
  iMouseY = VAL(Mem(0, 8))
  IF iMouseX < iLeft THEN aTemp = 0
  IF iMouseY < iTop THEN aTemp = 0
  IF iMouseX > iLeft + iWidth THEN aTemp = 0
  IF iMouseY > iTop + iHeight THEN aTemp = 0
  MouseInArea% = aTemp
END FUNCTION

SUB MouseRefresh
  Future.MouseOn
  Mem(0, 9) = "1"
END SUB

SUB NextChr (PID AS INTEGER)
  Mem(PID, 1) = Trim$(STR$(VAL(Mem(PID, 1)) + 1))
END SUB

FUNCTION notUnderZero (iNum AS INTEGER)
  IF iNum < 0 THEN
    notUnderZero = 0
  ELSE
    notUnderZero = iNum
  END IF
END FUNCTION

FUNCTION requestNewPID
  FOR Looper = 1 TO 20
    IF Mem(Looper, 2) = "" THEN
      requestNewPID = Looper
      EXIT FOR
    END IF
  NEXT
END FUNCTION

SUB ResetZOrder (PID AS INTEGER)
  ZOrder = VAL(Mem(PID, 5))
  FOR LooperID = 1 TO 20
    IF VAL(Mem(LooperID, 5)) > ZOrder THEN
      Mem(LooperID, 5) = Trim$(STR$(VAL(Mem(LooperID, 5)) - 1))
    END IF
  NEXT
  Mem(PID, 5) = "20"
END SUB

SUB RestoreDashedBorder (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER)
  IF iWidth > 1023 OR iHeight > 1023 THEN EXIT SUB
  FOR Looper = 0 TO iWidth / 2 STEP 1
    Future.PSet iX + (Looper * 2), iY, DashedBorder(Looper, 0)
    Future.PSet iX + (Looper * 2), iY + iHeight, DashedBorder(Looper, 1)
  NEXT
  FOR Looper = 0 TO iHeight / 2 STEP 1
    Future.PSet iX, iY + (Looper * 2), DashedBorder(Looper, 2)
    Future.PSet iX + iWidth, iY + (Looper * 2), DashedBorder(Looper, 3)
  NEXT
END SUB

FUNCTION returnFontWidth (iStr AS STRING)
    FOR Looper = 1 TO LEN(iStr)
        CurPos = 1
        CChr = ASC(MID$(iStr, Looper, 1))
        IF NOT MID$(iStr, Looper, 1) = " " THEN
            CLoc = CLoc + iFontX(CChr) + FontSpacing
        ELSE
            CLoc = CLoc + FontSpace
        END IF
    NEXT
    returnFontWidth = CLoc
END FUNCTION

SUB runRoutine (PID AS INTEGER, iStr AS STRING)
  DIM curChr AS STRING * 1
  DIM strStartSub AS STRING * 1
  DIM strEndSub AS STRING * 1
  DIM IsInRoutine AS INTEGER
  iStr = LCASE$(iStr)
  IF iStr = "init" THEN
    strStartSub = CHR$(161): strEndSub = CHR$(162)
  ELSEIF iStr = "refresh" THEN
    strStartSub = CHR$(163): strEndSub = CHR$(164)
  ELSEIF iStr = "mouseon" THEN
    strStartSub = CHR$(165): strEndSub = CHR$(166)
  ELSEIF iStr = "mouseoff" THEN
    strStartSub = CHR$(167): strEndSub = CHR$(168)
  ELSEIF iStr = "program" THEN
    strStartSub = CHR$(169): strEndSub = CHR$(170)
  END IF
  Filenum = FREEFILE
  OPEN Mem(PID, 4) FOR INPUT AS #Filenum
    LINE INPUT #Filenum, aTemp$
  CLOSE #Filenum
  Mem(PID, 0) = aTemp$
  aTemp$ = ""
  FOR Looper = 1 TO LEN(Mem(PID, 0)) STEP 1
    Mem(PID, 1) = Trim$(STR$(Looper))
    curChr = MID$(Mem(PID, 0), Looper, 1)
    IF IsInRoutine = 0 THEN
      IF curChr = strStartSub THEN
        IsInRoutine = 1
      END IF
    ELSE
      IF curChr = strEndSub THEN
        IsInRoutine = 0
        EXIT FOR
      ELSE
        ExecCommand PID, curChr
      END IF
    END IF
    Looper = VAL(Mem(PID, 1))
  NEXT
  Mem(PID, 0) = ""
END SUB

SUB SetDashedBorder (iX AS INTEGER, iY AS INTEGER, iWidth AS INTEGER, iHeight AS INTEGER)
  FOR Looper = 0 TO iWidth / 2 STEP 1
    DashedBorder(Looper, 0) = Future.POINT(iX + (Looper * 2), iY)
    DashedBorder(Looper, 1) = Future.POINT(iX + (Looper * 2), iY + iHeight)
  NEXT
  FOR Looper = 0 TO iHeight / 2 STEP 1
    DashedBorder(Looper, 2) = Future.POINT(iX, iY + (Looper * 2))
    DashedBorder(Looper, 3) = Future.POINT(iX + iWidth, iY + (Looper * 2))
  NEXT
END SUB

SUB SwapPage
  iCurPage = VAL(Mem(0, 5))
  IF iCurPage = 0 THEN
    Mem(0, 5) = "1"
    SetPage 1
  ELSEIF iCurPage = 1 THEN
    Mem(0, 5) = "0"
    SetPage 0
  END IF
END SUB

SUB SystemRefresh
  MouseClear
  SwapPage
  Future.FillBox 0, 0, VAL(Mem(0, 2)), VAL(Mem(0, 3)), GetClr(30, 0)
  FOR Looper = 1 TO 20
    FOR LooperID = 1 TO 20
      IF VAL(Mem(LooperID, 5)) = Looper THEN
        iLeft = VAL(Mem(LooperID, 6))
        iTop = VAL(Mem(LooperID, 7))
        iWidth = VAL(Mem(LooperID, 8))
        iHeight = VAL(Mem(LooperID, 9))
        runRoutine LooperID, "refresh"
        SetViewPort 0, 0, VAL(Mem(0, 2)), VAL(Mem(0, 3))
      END IF
    NEXT
  NEXT
  CurPage
  MouseRefresh
END SUB

FUNCTION Trim$ (iStr AS STRING)
  Trim$ = LTRIM$(RTRIM$(iStr))
END FUNCTION

SUB UpdateMouse
  Future.UpdateMouse
  Mem(0, 10) = Mem(0, 6)
  Mem(0, 6) = Trim$(STR$(Future.MouseB))
  Mem(0, 7) = Trim$(STR$(Future.MouseX))
  Mem(0, 8) = Trim$(STR$(Future.MouseY))
END SUB

