// ==========================================
//  GCOE G2 Default Startup Application v0.4
//  Part of GCOE G2 System 1.0
// ==========================================

// ==[ meta declares ]=======================

  #dim program.data, 0
  #dim program.byteposition, 1
  #dim program.id, 2
  #dim program.active, 3
  #dim program.filename, 4
  #dim window.zorder, 5
  #dim window.left, 6
  #dim window.top, 7
  #dim window.width, 8
  #dim window.height, 9
  #dim window.caption, 10
  #dim window.resize, 11

  // init:
  #dim screen.width, 16
  #dim screen.height, 17
  #dim screen.bitrate, 21
  #dim filenum, 18
  #dim window.x2, 21
  #dim window.y2, 22
  #dim window.x, 19
  #dim window.y, 20
  #dim color.longvalue, 23
  #dim color.current, 24
  #dim color.memoryaddress, 25
  #dim color.r, 26
  #dim color.g, 27
  #dim color.b, 28
  #dim color.loop, 29
  #dim eof, 30

  // refresh:
  #dim kernal.version, 16
  #dim shutdown.left, 40
  #dim shutdown.top, 41

// ==[ program ]=============================


// program routine is disabled in the [init] section.
// [program]
// [/program]

// ==[ mouse press ]=========================

[mouseon]
  math _shutdown.left, window.width, -, 94
  click shutdown.left, shutdown.top, 80, 19
    mouseClear
    buttondown shutdown.left, shutdown.top, 80, 19, "Shutdown"
    mouseRefresh
  endclick
  math _shutdown.left, shutdown.left, -, 120
  click shutdown.left, shutdown.top, 110, 19
    mouseClear
    buttondown shutdown.left, shutdown.top, 110, 19, "Process Manager"
    mouseRefresh
  endclick
  set 3, 1
[/mouseon]

// ==[ mouse release ]=======================

[mouseoff]
  math _shutdown.left, window.width, -, 94
  click shutdown.left, shutdown.top, 80, 19
    mouseClear
    buttonup shutdown.left, shutdown.top, 80, 19, "Shutdown"
    mouseRefresh
    dmw 0, 23, "1"
  endclick
  math _shutdown.left, shutdown.left, -, 120
  click shutdown.left, shutdown.top, 110, 19
    mouseClear
    buttonup shutdown.left, shutdown.top, 110, 19, "Process Manager"
    mouseRefresh
    dmw 0, 20, "sys\procman.exe"
  endclick
[/mouseoff]

// ==[ refresh ]=============================

[refresh]
  // redraw the window
  refreshWindow

  // limit the graphics draw area
  winDrawArea

  // load the gcoe g2 logo
  loadimage "sys\img\logo.bmp", 0, 10
 
  // put the button in the lower left corner
  math _shutdown.left, window.width, -, 94
  math _shutdown.top, window.height, -, 58
  buttonup shutdown.left, shutdown.top, 80, 19, "Shutdown"

  math _shutdown.left, shutdown.left, -, 120
  buttonup shutdown.left, shutdown.top, 110, 19, "Process Manager"

  // make the whole screen available for drawing
  resetDrawArea
[/refresh]

// ==[ init ]================================

[init]
  // disable the [program] routine
  set _program.active, 0

  // open the video settings file
  freefile _filenum
  fopen "sys\video.dat", 1, filenum

  // get the screen res settings
    finput filenum, _screen.width
    finput filenum, _screen.height
    finput filenum, _screen.bitrate

  // set the screen res
  setScreenMode screen.width, screen.height, screen.bitrate

  // read and set the color settings
  set _color.current, 0

  // start the file read loop:
  set _color.loop, program.byteposition
    finput filenum, _color.memoryaddress
    finput filenum, _color.r
    finput filenum, _color.g
    finput filenum, _color.b
    rgb _color.longvalue, color.r, color.g, color.b
    dmw 0, color.memoryaddress, color.longvalue
    math _color.current, color.current, +, 1
  if color.current < 12 then
    goto color.loop
  endif

  // set z-order darken level
  dmw 0, 50, 50

  fclose filenum

  // load the default system font.
  loadFont "sys\fnt\a10.fnt"

  // size the startup window and center it on screen
  set _window.width, 320
  set _window.height, 211

  // find the center of the screen
  math _window.x, screen.width, /, 2
  math _window.y, screen.height, /, 2

  // divide the windows width and height by 2
  math _window.x2, window.width, /, 2
  math _window.y2, window.height, /, 2

  // subtract half of the windows width and height from 
  // half of the screens width and height to find the center.
  math _window.left, window.x, -, window.x2
  math _window.top, window.y, -, window.y2

  // final window settings
  set _window.caption, ""
  set _window.resize, 0

  // initalize the mouse
  mouseRefresh
[/init]
